Index: /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIHotKeyEdit.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIHotKeyEdit.cpp	(revision 29920)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIHotKeyEdit.cpp	(revision 29921)
@@ -69,8 +69,6 @@
 # include "DarwinKeyboard.h"
 # include <Carbon/Carbon.h>
-# ifdef QT_MAC_USE_COCOA
-#  include "darwin/VBoxCocoaApplication.h"
-#  include "VBoxUtils.h"
-# endif
+# include "darwin/VBoxCocoaApplication.h"
+# include "VBoxUtils.h"
 #endif
 
@@ -653,5 +651,4 @@
 
 #elif defined (Q_WS_MAC)
-# ifdef QT_MAC_USE_COCOA
 /* static */
 bool QIHotKeyEdit::darwinEventHandlerProc (const void *pvCocoaEvent, const void *pvCarbonEvent, void *pvUser)
@@ -665,19 +662,4 @@
 }
 
-# else  /* !QT_MAC_USE_COCOA */
-/* static */
-pascal OSStatus QIHotKeyEdit::darwinEventHandlerProc (EventHandlerCallRef inHandlerCallRef,
-                                                      EventRef inEvent, void *inUserData)
-{
-    QIHotKeyEdit *edit = (QIHotKeyEdit *) inUserData;
-    UInt32 EventClass = ::GetEventClass (inEvent);
-    if (EventClass == kEventClassKeyboard)
-    {
-        if (edit->darwinKeyboardEvent (NULL, inEvent))
-            return 0;
-    }
-    return CallNextEventHandler (inHandlerCallRef, inEvent);
-}
-# endif /* !QT_MAC_USE_COCOA */
 
 bool QIHotKeyEdit::darwinKeyboardEvent (const void *pvCocoaEvent, EventRef inEvent)
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/VBoxGLSettingsGeneral.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/VBoxGLSettingsGeneral.cpp	(revision 29920)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/VBoxGLSettingsGeneral.cpp	(revision 29921)
@@ -31,7 +31,4 @@
     mCbCheckTrayIcon->hide();
 #endif /* VBOX_GUI_WITH_SYSTRAY */
-#ifndef QT_MAC_USE_COCOA
-    mCbCheckPresentationMode->hide();
-#endif /* QT_MAC_USE_COCOA */
     if (   mCbCheckTrayIcon->isHidden()
         && mCbCheckPresentationMode->isHidden())
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxToolBar.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxToolBar.h	(revision 29920)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxToolBar.h	(revision 29921)
@@ -22,5 +22,5 @@
 #include <QGlobalStatic> /* for Q_WS_MAC */
 #ifdef Q_WS_MAC
-#include "VBoxUtils.h"
+# include "VBoxUtils.h"
 #endif
 
@@ -66,44 +66,6 @@
     {
         if (mMainWindow)
-        {
             mMainWindow->setUnifiedTitleAndToolBarOnMac (true);
-#ifndef QT_MAC_USE_COCOA
-            WindowRef window = ::darwinToNativeWindow (this);
-            EventHandlerUPP eventHandler = ::NewEventHandlerUPP (VBoxToolBar::macEventFilter);
-            EventTypeSpec eventTypes[2];
-            eventTypes[0].eventClass = kEventClassMouse;
-            eventTypes[0].eventKind  = kEventMouseDown;
-            eventTypes[1].eventClass = kEventClassMouse;
-            eventTypes[1].eventKind  = kEventMouseUp;
-            InstallWindowEventHandler (window, eventHandler,
-                                       RT_ELEMENTS (eventTypes), eventTypes,
-                                       NULL, NULL);
-#endif /* !QT_MAC_USE_COCOA */
-        }
     }
-
-#ifndef QT_MAC_USE_COCOA
-    static pascal OSStatus macEventFilter (EventHandlerCallRef aNextHandler,
-                                           EventRef aEvent, void * /* aUserData */)
-    {
-        UInt32 eclass = GetEventClass (aEvent);
-        if (eclass == kEventClassMouse)
-        {
-            WindowPartCode partCode;
-            GetEventParameter (aEvent, kEventParamWindowPartCode, typeWindowPartCode, NULL, sizeof (WindowPartCode), NULL, &partCode);
-            UInt32 ekind = GetEventKind (aEvent);
-            if (partCode == 15 ||
-                partCode == 4)
-                if(ekind == kEventMouseDown || ekind == kEventMouseUp)
-                {
-                    EventMouseButton button = 0;
-                    GetEventParameter (aEvent, kEventParamMouseButton, typeMouseButton, NULL, sizeof (button), NULL, &button);
-                    if (button != kEventMouseButtonPrimary)
-                        return noErr;
-                }
-        }
-        return CallNextEventHandler (aNextHandler, aEvent);
-    }
-#endif /* !QT_MAC_USE_COCOA */
 
     void setShowToolBarButton (bool aShow)